/*
	`Function.apply()` test code for GNU Flash Player
	Written (2016) by Nutchanon Wetchasit <Nutchanon.Wetchasit@gmail.com>
	
	Released to public domain under Creative Commons Zero 1.0
	(https://creativecommons.org/publicdomain/zero/1.0/)
*/
#ifndef VERSION
#define VERSION 8
#endif

var tested=0;
var passed=0;
var failed=0;

var fn_nullthis;
var fn_undefinedthis;

/** Checker functions, print each test result to trace() */
var check=function(op,msg) {
	if(op) {
		trace("PASSED: "+msg);
		passed++;
	} else {
		trace("FAILED: "+msg);
		failed++;
	}
	tested++;
};
var check_equals=function(op1,op2,msg) {
	if(op1==op2) {
		trace("PASSED: "+msg);
		passed++;
	} else {
		trace("FAILED: "+msg+" (\""+op1+"\" != \""+op2+"\")");
		failed++;
	}
	tested++;
};

check_equals(typeof(_global),"object","_global object should be an object type");
check_equals(_global,undefined,"_global object should be equal to undefined value");
check_equals(_global,null,"_global object should be equal to null value");
#if VERSION >= 7
check_equals(""+_global,"undefined","Appending _global object to empty string should give \"undefined\" string");
#else
check_equals(""+_global,"","Appending _global object to empty string should give an empty string");
#endif
check(_global!==undefined,"_global object should not be strictly equal to undefined value");
check(_global!==null,"_global object should not be strictly equal to null value");

fn_nullthis=function() {
	check_equals(typeof(this),"object","this pointer inside fn_nullthis should be an object type");
	check_equals(this,undefined,"this pointer inside fn_nullthis should be equal to undefined value");
	check_equals(this,null,"this pointer inside fn_nullthis should be equal to null value");
	#if VERSION >= 7
	check_equals(""+this,"undefined","Appending this pointer inside fn_nullthis to empty string should give \"undefined\" string");
	#else
	check_equals(""+this,"","Appending this pointer inside fn_nullthis to empty string should give an empty string");
	#endif
	check(this!==undefined,"this pointer inside fn_nullthis should not be strictly equal to undefined value");
	check(this!==null,"this pointer inside fn_nullthis should not be strictly equal to null value");
	check(this===_global,"this pointer inside fn_nullthis should be strictly equal to _global object");
	this.nullthis_value="fn_nullthis";
};
fn_undefinedthis=function() {
	check_equals(typeof(this),"object","this pointer inside fn_undefinedthis should be an object type");
	check_equals(this,undefined,"this pointer inside fn_undefinedthis should be equal to undefined value");
	check_equals(this,null,"this pointer inside fn_undefinedthis should be equal to null value");
	#if VERSION >= 7
	check_equals(""+this,"undefined","Appending this pointer inside fn_undefinedthis to empty string should give \"undefined\" string");
	#else
	check_equals(""+this,"","Appending this pointer inside fn_undefinedthis to empty string should give an empty string");
	#endif
	check(this!==undefined,"this pointer inside fn_undefinedthis should not be strictly equal to undefined value");
	check(this!==null,"this pointer inside fn_undefinedthis should not be strictly equal to null value");
	check(this===_global,"this pointer inside fn_undefinedthis should be strictly equal to _global object");
	this.undefinedthis_value="fn_undefinedthis";
};

fn_nullthis.apply(null);
fn_undefinedthis.apply(undefined);

check_equals(_global.nullthis_value,"fn_nullthis","_global.nullthis_value should be set to the correct value");
check_equals(_global.undefinedthis_value,"fn_undefinedthis","_global.undefinedthis_value should be set to the correct value");
check_equals(tested,22,"There should be 22 tests run");
